Package org.zkoss.stateless.sul

## Interface ILinelayout

- All Superinterfaces:
    `IAnyGroup<ILinelayout>`, `IChildable<ILinelayout,​ILineitem<IAnyGroup>>`, `IComponent<ILinelayout>`, `IHtmlBasedComponent<ILinelayout>`, `IXulElement<ILinelayout>`

      public interface ILinelayout
      extends IXulElement<ILinelayout>, IChildable<ILinelayout,​ILineitem<IAnyGroup>>, IAnyGroup<ILinelayout>

  Immutable `Linelayout` component

  A linelayout component for stylistically displaying chronological information.

  Author:
    katherine
  See Also:
    `Linelayout`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Interface | Description
    --- | --- | ---
    `static class` | `ILinelayout.Builder` | Builds instances of type `ILinelayout`.
    `static class` | `ILinelayout.Orient` | Specifies the orient of `ICardlayout` component
    `static class` | `ILinelayout.Updater` | Builds an updater of type `ILinelayout` for `UiAgent.smartUpdate(Locator, SmartUpdater)`.

  - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static ILinelayout` | `DEFAULT` | Constant for default attributes of this immutable component.

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `default int` | `getFirstScale()` | Returns the scale of space occupied by the first area.
    `default int` | `getLastScale()` | Returns the scale of space occupied by the last area.
    `java.lang.String` | `getLineStyle()` | Returns the CSS style for the line.
    `default java.lang.String` | `getOrient()` | Returns the orient.
    `default java.lang.String` | `getWidgetClass()` | Returns the client widget class.
    `static ILinelayout` | `of​(java.lang.Iterable<? extends ILineitem<IAnyGroup>> children)` | Returns the instance with the given `ILineitem` children.
    `static ILinelayout` | `of​(ILineitem<IAnyGroup>... children)` | Returns the instance with the given `ILineitem` children.
    `static ILinelayout` | `ofId​(java.lang.String id)` | Returns the instance with the given id.
    `static ILinelayout` | `ofOrient​(ILinelayout.Orient orient)` | Returns the instance with the given orient.
    `ILinelayout` | `withFirstScale​(int firstScale)` | Returns a copy of `this` immutable component with the specified `firstScale`.
    `ILinelayout` | `withLastScale​(int lastScale)` | Returns a copy of `this` immutable component with the specified `lastScale`.
    `ILinelayout` | `withLineStyle​(java.lang.String lineStyle)` | Returns a copy of `this` immutable component with the specified `lineStyle`.
    `ILinelayout` | `withOrient​(java.lang.String orient)` | Returns a copy of `this` immutable component with the specified `orient`.
    `default ILinelayout` | `withOrient​(ILinelayout.Orient orient)` | Returns a copy of `this` immutable component with the specified `orient`.

    - ### Methods inherited from interface org.zkoss.stateless.sul.IChildable

      `getChildren, withChildren, withChildren`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IComponent

      `getAction, getActions, getClientAttributes, getId, getMold, getWidgetListeners, getWidgetOverrides, isVisible, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withAction, withActions, withActions, withClientAttribute, withClientAttributes, withId, withMold, withVisible, withWidgetClass, withWidgetListener, withWidgetListeners, withWidgetOverride, withWidgetOverrides`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IHtmlBasedComponent

      `getClientAction, getDraggable, getDroppable, getHeight, getHflex, getLeft, getRenderdefer, getSclass, getStyle, getTabindex, getTooltiptext, getTop, getVflex, getWidth, getZclass, getZIndex, isFocus, withClientAction, withDraggable, withDroppable, withFocus, withHeight, withHflex, withLeft, withRenderdefer, withSclass, withStyle, withTabindex, withTabindex, withTooltiptext, withTop, withVflex, withWidth, withZclass, withZIndex`

    - ### Methods inherited from interface org.zkoss.stateless.sul.IXulElement

      `getContext, getCtrlKeys, getPopup, getTooltip, withContext, withCtrlKeys, withPopup, withTooltip`

- - ### Field Detail

    - #### DEFAULT

          static final ILinelayout DEFAULT

      Constant for default attributes of this immutable component.

  - ### Method Detail

    - #### getWidgetClass

          default java.lang.String getWidgetClass()

      Returns the client widget class.

      Default: `"zkmax.layout.Linelayout"`

      Specified by:
        `getWidgetClass` in interface `IComponent<ILinelayout>`

    - #### getLineStyle

          @Nullable
          java.lang.String getLineStyle()

      Returns the CSS style for the line.

      Default: `null`

    - #### withLineStyle

          ILinelayout withLineStyle​(@Nullable
                                    java.lang.String lineStyle)

      Returns a copy of `this` immutable component with the specified `lineStyle`.

      Sets the CSS style for the line.

      Parameters:
        `lineStyle` - Sets the CSS style for the line.

        Default: `null`.

      Returns:
        A modified copy of the `this` object

    - #### getOrient

          default java.lang.String getOrient()

      Returns the orient.

      Default: `"vertical"`.

    - #### withOrient

          ILinelayout withOrient​(java.lang.String orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient.

      Parameters:
        `orient` - Either `"horizontal"` or `vertical`

        Default: `"vertical"`.

      Returns:
        A modified copy of the `this` object

    - #### withOrient

          default ILinelayout withOrient​(ILinelayout.Orient orient)

      Returns a copy of `this` immutable component with the specified `orient`.

      Sets the orient of component

      Parameters:
        `orient` - The `orient`

        Default: `"horizontal"`.

      Returns:
        A modified copy of the `this` object

    - #### getFirstScale

          default int getFirstScale()

      Returns the scale of space occupied by the first area.

      Default: `1`.

    - #### withFirstScale

          ILinelayout withFirstScale​(int firstScale)

      Returns a copy of `this` immutable component with the specified `firstScale`.

      Sets the scale of space occupied by the first area.

      Parameters:
        `firstScale` - The scale of space occupied by the first area.

        Default: `1`.

      Returns:
        A modified copy of the `this` object

    - #### getLastScale

          default int getLastScale()

      Returns the scale of space occupied by the last area.

      Default: `1`.

    - #### withLastScale

          ILinelayout withLastScale​(int lastScale)

      Returns a copy of `this` immutable component with the specified `lastScale`.

      Sets the scale of space occupied by the last area.

      Parameters:
        `lastScale` - The scale of space occupied by the last area.

        Default: `1`.

      Returns:
        A modified copy of the `this` object

    - #### of

          static ILinelayout of​(java.lang.Iterable<? extends ILineitem<IAnyGroup>> children)

      Returns the instance with the given `ILineitem` children.
      Parameters:
        `children` - The children of `ILineitem`

    - #### of

          static ILinelayout of​(ILineitem<IAnyGroup>... children)

      Returns the instance with the given `ILineitem` children.
      Parameters:
        `children` - The children of `ILineitem`

    - #### ofOrient

          static ILinelayout ofOrient​(ILinelayout.Orient orient)

      Returns the instance with the given orient.
      Parameters:
        `orient` - The orient of this component.

    - #### ofId

          static ILinelayout ofId​(java.lang.String id)

      Returns the instance with the given id.
      Parameters:
        `id` - The id to identify this component